default:
  image: registry.gitlab.com/centos/automotive/rpms/kmod-memscav/kmod-ci:latest
  before_script:
    - git config --global user.name "$CI_BOT_NAME"
    - git config --global user.email "$CI_BOT_NAME@noreply.$CI_SERVER_FQDN"

variables:
  FF_SCRIPT_SECTIONS: 1
  SPECFILE: "memscav.spec"

stages:
  - sync
  - build

kernel_version:
  rules:
    - if: $CI_PIPELINE_SOURCE == "schedule" && $CI_COMMIT_REF_PROTECTED == "true"
      when: always
    - if: $CI_COMMIT_REF_PROTECTED == "true"
      when: manual
  stage: sync
  script:
    - LATEST_KERNEL="$(dnf repoquery -q --queryformat='%{version}-%{release}' --latest-limit 1 kernel | sed -e 's|\.[^.]\+$||')"
    - LATEST_KERNEL_AUTOMOTIVE="$(cbs list-tagged --latest autosd9s-packages-main-release | sed -ne 's|^kernel-automotive-\([0-9.-]\+\)\.el9iv.*|\1|p')"
    - SPEC_LATEST_KERNEL="$(sed -ne 's|^%global\s\+latest_kernel \([0-9.]\+-[0-9]\+\)%{dist}\.%{_arch}|\1|p' "$SPECFILE")"
    - SPEC_LATEST_KERNEL_AUTOMOTIVE="$(sed -ne 's|^%global\s\+latest_kernel_automotive \([0-9.]\+-[0-9.]\+\)%{dist}\.%{_arch}|\1|p' "$SPECFILE")"
    - |
      if [[ "$LATEST_KERNEL" = "$SPEC_LATEST_KERNEL" ]] && \
         [[ "$LATEST_KERNEL_AUTOMOTIVE" = "$SPEC_LATEST_KERNEL_AUTOMOTIVE" ]]; then
              exit 0
      fi
    - |
      sed -i -e 's|\(^%global\s\+latest_kernel\s\+\).*|\1'"$LATEST_KERNEL"'%{dist}.%{_arch}|' \
             -e 's|\(^%global\s\+latest_kernel_automotive\s\+\).*|\1'"$LATEST_KERNEL_AUTOMOTIVE"'%{dist}.%{_arch}|' \
             -e 's|^\(Release:\s\+\).*|\11%{?dist}|' \
                      "$SPECFILE"
    - git config --global user.name "$CI_BOT_NAME"
    - git config --global user.email "$CI_BOT_NAME@noreply.$CI_SERVER_FQDN"
    - git add "$SPECFILE"
    - |
      git commit -m "spec: kernel version tracking"
    - git remote set-url origin --push "https://$CI_BOT_NAME:$ACCESS_TOKEN@$CI_SERVER_HOST/$CI_PROJECT_PATH.git"
    - git push origin HEAD:"$CI_COMMIT_BRANCH"

cbs:
  rules:
    - if: $CI_PIPELINE_SOURCE == "push" && $CI_COMMIT_REF_PROTECTED == "true"
      when: always
    - if: $CI_COMMIT_REF_PROTECTED == "true"
      when: manual
  stage: build
  needs: []
  script:
    - NVR="$(rpmspec -q --srpm --define "dist .el9iv" --queryformat='%{name}-%{version}-%{release}\n' "$SPECFILE")"
    - |
      if ! cbs buildinfo "$NVR" 2>/dev/null | grep -q 'State: COMPLETE'; then
              cbs --cert="$CBS_CERT" build automotive9s-packages-main-el9s --wait "git+$CI_PROJECT_URL#$CI_COMMIT_SHA"
      fi
